#ifndef _AUTO_REF2_H_
#define _AUTO_REF2_H_


template<class T>class _auto_ref{
protected:
	struct item_st{	
		T obj;
		int count;
	}*data_ref;
	void Free(item_st *ref) {
		if(ref && !--ref->count) delete ref;
	}
public:
	_auto_ref &operator =(_auto_ref &obj) {
		item_st *temp=data_ref;
		data_ref=obj.data_ref;
		if(data_ref) data_ref->count++;
		Free(temp);
		return *this;
	}
	bool operator !=(_auto_ref &obj) {
		return data_ref!=obj.data_ref;
	}
	_auto_ref &operator =(const T &obj) {
		data_ref->obj=obj;
		return *this;
	}
	T *operator ->() { 
		return &data_ref->obj;
	}
	_auto_ref &operator ^=(_auto_ref &obj) {
		item_st *temp=data_ref;
		data_ref=obj.data_ref;
		obj.data_ref=temp;
		return *this;
	}
	operator T&() {
		return data_ref->obj;
	}
	operator T*() {
		return &data_ref->obj;
	}
	void clone()
	{
		if(!data_ref) return;
		item_st *temp=data_ref;
		data_ref=new item_st;
		data_ref->count=1;
		data_ref->obj=temp->obj;
		Free(temp);
	}
	bool isInit() {
		return data_ref!=0;
	}
	_auto_ref() { 
		data_ref=0;
	}
	_auto_ref(const _auto_ref<T> &obj) {
		data_ref=0;
		operator=((_auto_ref&)obj);
	}
	~_auto_ref() {
		Free(data_ref);
	}
};


template<class T>class auto_ref:public _auto_ref<T>{
public:
	auto_ref()
	{
		data_ref=new item_st; 
		data_ref->count=1;
	}
	auto_ref &operator =(_auto_ref<T> &obj) {
		return _auto_ref<T>::operator=(obj);
	}
	auto_ref &operator =(const T &obj) {
		return _auto_ref<T>::operator=(obj);
	}
};


#endif

